install.sh 17 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281282283284285286287288289290291292293294295296297298299300301302303304305306307308309310311312313314315316317318319320321322323324325326327328329330331332333334335336337338339340341342343344345346347348349350351352353354355356357358359360361362363364365366367368369370371372373374375376377378379380381382383384385386387388389390391392393394395396397398399400401402403404405406407408409410411412413414415416417418419420421422423424425426427428429430431432433434435436437438439440441442443444445446447448449450451452453454455456457458459460461462463464465466467468469470471472473474475476477478479480481482483484485486487488489490491492493494495496497498499500501502503504505506507508509510511512513514515516517518519520521522523524525526527528529530531532533534535536537538
  1. #!/bin/sh
  2. #
  3. # This script should be run via curl:
  4. # sh -c "$(curl -fsSL https://raw.githubusercontent.com/ohmyzsh/ohmyzsh/master/tools/install.sh)"
  5. # or via wget:
  6. # sh -c "$(wget -qO- https://raw.githubusercontent.com/ohmyzsh/ohmyzsh/master/tools/install.sh)"
  7. # or via fetch:
  8. # sh -c "$(fetch -o - https://raw.githubusercontent.com/ohmyzsh/ohmyzsh/master/tools/install.sh)"
  9. #
  10. # As an alternative, you can first download the install script and run it afterwards:
  11. # wget https://raw.githubusercontent.com/ohmyzsh/ohmyzsh/master/tools/install.sh
  12. # sh install.sh
  13. #
  14. # You can tweak the install behavior by setting variables when running the script. For
  15. # example, to change the path to the Oh My Zsh repository:
  16. # ZSH=~/.zsh sh install.sh
  17. #
  18. # Respects the following environment variables:
  19. # ZDOTDIR - path to Zsh dotfiles directory (default: unset). See [1][2]
  20. # [1] https://zsh.sourceforge.io/Doc/Release/Parameters.html#index-ZDOTDIR
  21. # [2] https://zsh.sourceforge.io/Doc/Release/Files.html#index-ZDOTDIR_002c-use-of
  22. # ZSH - path to the Oh My Zsh repository folder (default: $HOME/.oh-my-zsh)
  23. # REPO - name of the GitHub repo to install from (default: ohmyzsh/ohmyzsh)
  24. # REMOTE - full remote URL of the git repo to install (default: GitHub via HTTPS)
  25. # BRANCH - branch to check out immediately after install (default: master)
  26. #
  27. # Other options:
  28. # CHSH - 'no' means the installer will not change the default shell (default: yes)
  29. # RUNZSH - 'no' means the installer will not run zsh after the install (default: yes)
  30. # KEEP_ZSHRC - 'yes' means the installer will not replace an existing .zshrc (default: no)
  31. #
  32. # You can also pass some arguments to the install script to set some these options:
  33. # --skip-chsh: has the same behavior as setting CHSH to 'no'
  34. # --unattended: sets both CHSH and RUNZSH to 'no'
  35. # --keep-zshrc: sets KEEP_ZSHRC to 'yes'
  36. # For example:
  37. # sh install.sh --unattended
  38. # or:
  39. # sh -c "$(curl -fsSL https://raw.githubusercontent.com/ohmyzsh/ohmyzsh/master/tools/install.sh)" "" --unattended
  40. #
  41. set -e
  42. # Make sure important variables exist if not already defined
  43. #
  44. # $USER is defined by login(1) which is not always executed (e.g. containers)
  45. # POSIX: https://pubs.opengroup.org/onlinepubs/009695299/utilities/id.html
  46. USER=${USER:-$(id -u -n)}
  47. # $HOME is defined at the time of login, but it could be unset. If it is unset,
  48. # a tilde by itself (~) will not be expanded to the current user's home directory.
  49. # POSIX: https://pubs.opengroup.org/onlinepubs/009696899/basedefs/xbd_chap08.html#tag_08_03
  50. HOME="${HOME:-$(getent passwd $USER 2>/dev/null | cut -d: -f6)}"
  51. # macOS does not have getent, but this works even if $HOME is unset
  52. HOME="${HOME:-$(eval echo ~$USER)}"
  53. # Track if $ZSH was provided
  54. custom_zsh=${ZSH:+yes}
  55. # Use $zdot to keep track of where the directory is for zsh dotfiles
  56. # To check if $ZDOTDIR was provided, explicitly check for $ZDOTDIR
  57. zdot="${ZDOTDIR:-$HOME}"
  58. # Default value for $ZSH
  59. # a) if $ZDOTDIR is supplied: $ZDOTDIR/ohmyzsh
  60. # b) otherwise, $HOME/.oh-my-zsh
  61. ZSH="${ZSH:-${ZDOTDIR:+$ZDOTDIR/ohmyzsh}}"
  62. ZSH="${ZSH:-$HOME/.oh-my-zsh}"
  63. # Default settings
  64. REPO=${REPO:-ohmyzsh/ohmyzsh}
  65. REMOTE=${REMOTE:-https://github.com/${REPO}.git}
  66. BRANCH=${BRANCH:-master}
  67. # Other options
  68. CHSH=${CHSH:-yes}
  69. RUNZSH=${RUNZSH:-yes}
  70. KEEP_ZSHRC=${KEEP_ZSHRC:-no}
  71. command_exists() {
  72. command -v "$@" >/dev/null 2>&1
  73. }
  74. user_can_sudo() {
  75. # Check if sudo is installed
  76. command_exists sudo || return 1
  77. # The following command has 3 parts:
  78. #
  79. # 1. Run `sudo` with `-v`. Does the following:
  80. # • with privilege: asks for a password immediately.
  81. # • without privilege: exits with error code 1 and prints the message:
  82. # Sorry, user <username> may not run sudo on <hostname>
  83. #
  84. # 2. Pass `-n` to `sudo` to tell it to not ask for a password. If the
  85. # password is not required, the command will finish with exit code 0.
  86. # If one is required, sudo will exit with error code 1 and print the
  87. # message:
  88. # sudo: a password is required
  89. #
  90. # 3. Check for the words "may not run sudo" in the output to really tell
  91. # whether the user has privileges or not. For that we have to make sure
  92. # to run `sudo` in the default locale (with `LANG=`) so that the message
  93. # stays consistent regardless of the user's locale.
  94. #
  95. ! LANG= sudo -n -v 2>&1 | grep -q "may not run sudo"
  96. }
  97. # The [ -t 1 ] check only works when the function is not called from
  98. # a subshell (like in `$(...)` or `(...)`, so this hack redefines the
  99. # function at the top level to always return false when stdout is not
  100. # a tty.
  101. if [ -t 1 ]; then
  102. is_tty() {
  103. true
  104. }
  105. else
  106. is_tty() {
  107. false
  108. }
  109. fi
  110. # This function uses the logic from supports-hyperlinks[1][2], which is
  111. # made by Kat Marchán (@zkat) and licensed under the Apache License 2.0.
  112. # [1] https://github.com/zkat/supports-hyperlinks
  113. # [2] https://crates.io/crates/supports-hyperlinks
  114. #
  115. # Copyright (c) 2021 Kat Marchán
  116. #
  117. # Licensed under the Apache License, Version 2.0 (the "License");
  118. # you may not use this file except in compliance with the License.
  119. # You may obtain a copy of the License at
  120. #
  121. # http://www.apache.org/licenses/LICENSE-2.0
  122. #
  123. # Unless required by applicable law or agreed to in writing, software
  124. # distributed under the License is distributed on an "AS IS" BASIS,
  125. # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  126. # See the License for the specific language governing permissions and
  127. # limitations under the License.
  128. supports_hyperlinks() {
  129. # $FORCE_HYPERLINK must be set and be non-zero (this acts as a logic bypass)
  130. if [ -n "$FORCE_HYPERLINK" ]; then
  131. [ "$FORCE_HYPERLINK" != 0 ]
  132. return $?
  133. fi
  134. # If stdout is not a tty, it doesn't support hyperlinks
  135. is_tty || return 1
  136. # DomTerm terminal emulator (domterm.org)
  137. if [ -n "$DOMTERM" ]; then
  138. return 0
  139. fi
  140. # VTE-based terminals above v0.50 (Gnome Terminal, Guake, ROXTerm, etc)
  141. if [ -n "$VTE_VERSION" ]; then
  142. [ $VTE_VERSION -ge 5000 ]
  143. return $?
  144. fi
  145. # If $TERM_PROGRAM is set, these terminals support hyperlinks
  146. case "$TERM_PROGRAM" in
  147. Hyper|iTerm.app|terminology|WezTerm) return 0 ;;
  148. esac
  149. # kitty supports hyperlinks
  150. if [ "$TERM" = xterm-kitty ]; then
  151. return 0
  152. fi
  153. # Windows Terminal also supports hyperlinks
  154. if [ -n "$WT_SESSION" ]; then
  155. return 0
  156. fi
  157. # Konsole supports hyperlinks, but it's an opt-in setting that can't be detected
  158. # https://github.com/ohmyzsh/ohmyzsh/issues/10964
  159. # if [ -n "$KONSOLE_VERSION" ]; then
  160. # return 0
  161. # fi
  162. return 1
  163. }
  164. # Adapted from code and information by Anton Kochkov (@XVilka)
  165. # Source: https://gist.github.com/XVilka/8346728
  166. supports_truecolor() {
  167. case "$COLORTERM" in
  168. truecolor|24bit) return 0 ;;
  169. esac
  170. case "$TERM" in
  171. iterm |\
  172. tmux-truecolor |\
  173. linux-truecolor |\
  174. xterm-truecolor |\
  175. screen-truecolor) return 0 ;;
  176. esac
  177. return 1
  178. }
  179. fmt_link() {
  180. # $1: text, $2: url, $3: fallback mode
  181. if supports_hyperlinks; then
  182. printf '\033]8;;%s\033\\%s\033]8;;\033\\\n' "$2" "$1"
  183. return
  184. fi
  185. case "$3" in
  186. --text) printf '%s\n' "$1" ;;
  187. --url|*) fmt_underline "$2" ;;
  188. esac
  189. }
  190. fmt_underline() {
  191. is_tty && printf '\033[4m%s\033[24m\n' "$*" || printf '%s\n' "$*"
  192. }
  193. # shellcheck disable=SC2016 # backtick in single-quote
  194. fmt_code() {
  195. is_tty && printf '`\033[2m%s\033[22m`\n' "$*" || printf '`%s`\n' "$*"
  196. }
  197. fmt_error() {
  198. printf '%sError: %s%s\n' "${FMT_BOLD}${FMT_RED}" "$*" "$FMT_RESET" >&2
  199. }
  200. setup_color() {
  201. # Only use colors if connected to a terminal
  202. if ! is_tty; then
  203. FMT_RAINBOW=""
  204. FMT_RED=""
  205. FMT_GREEN=""
  206. FMT_YELLOW=""
  207. FMT_BLUE=""
  208. FMT_BOLD=""
  209. FMT_RESET=""
  210. return
  211. fi
  212. if supports_truecolor; then
  213. FMT_RAINBOW="
  214. $(printf '\033[38;2;255;0;0m')
  215. $(printf '\033[38;2;255;97;0m')
  216. $(printf '\033[38;2;247;255;0m')
  217. $(printf '\033[38;2;0;255;30m')
  218. $(printf '\033[38;2;77;0;255m')
  219. $(printf '\033[38;2;168;0;255m')
  220. $(printf '\033[38;2;245;0;172m')
  221. "
  222. else
  223. FMT_RAINBOW="
  224. $(printf '\033[38;5;196m')
  225. $(printf '\033[38;5;202m')
  226. $(printf '\033[38;5;226m')
  227. $(printf '\033[38;5;082m')
  228. $(printf '\033[38;5;021m')
  229. $(printf '\033[38;5;093m')
  230. $(printf '\033[38;5;163m')
  231. "
  232. fi
  233. FMT_RED=$(printf '\033[31m')
  234. FMT_GREEN=$(printf '\033[32m')
  235. FMT_YELLOW=$(printf '\033[33m')
  236. FMT_BLUE=$(printf '\033[34m')
  237. FMT_BOLD=$(printf '\033[1m')
  238. FMT_RESET=$(printf '\033[0m')
  239. }
  240. setup_ohmyzsh() {
  241. # Prevent the cloned repository from having insecure permissions. Failing to do
  242. # so causes compinit() calls to fail with "command not found: compdef" errors
  243. # for users with insecure umasks (e.g., "002", allowing group writability). Note
  244. # that this will be ignored under Cygwin by default, as Windows ACLs take
  245. # precedence over umasks except for filesystems mounted with option "noacl".
  246. umask g-w,o-w
  247. echo "${FMT_BLUE}Cloning Oh My Zsh...${FMT_RESET}"
  248. command_exists git || {
  249. fmt_error "git is not installed"
  250. exit 1
  251. }
  252. ostype=$(uname)
  253. if [ -z "${ostype%CYGWIN*}" ] && git --version | grep -Eq 'msysgit|windows'; then
  254. fmt_error "Windows/MSYS Git is not supported on Cygwin"
  255. fmt_error "Make sure the Cygwin git package is installed and is first on the \$PATH"
  256. exit 1
  257. fi
  258. # Manual clone with git config options to support git < v1.7.2
  259. git init --quiet "$ZSH" && cd "$ZSH" \
  260. && git config core.eol lf \
  261. && git config core.autocrlf false \
  262. && git config fsck.zeroPaddedFilemode ignore \
  263. && git config fetch.fsck.zeroPaddedFilemode ignore \
  264. && git config receive.fsck.zeroPaddedFilemode ignore \
  265. && git config oh-my-zsh.remote origin \
  266. && git config oh-my-zsh.branch "$BRANCH" \
  267. && git remote add origin "$REMOTE" \
  268. && git fetch --depth=1 origin \
  269. && git checkout -b "$BRANCH" "origin/$BRANCH" || {
  270. [ ! -d "$ZSH" ] || {
  271. cd -
  272. rm -rf "$ZSH" 2>/dev/null
  273. }
  274. fmt_error "git clone of oh-my-zsh repo failed"
  275. exit 1
  276. }
  277. # Exit installation directory
  278. cd -
  279. echo
  280. }
  281. setup_zshrc() {
  282. # Keep most recent old .zshrc at .zshrc.pre-oh-my-zsh, and older ones
  283. # with datestamp of installation that moved them aside, so we never actually
  284. # destroy a user's original zshrc
  285. echo "${FMT_BLUE}Looking for an existing zsh config...${FMT_RESET}"
  286. # Must use this exact name so uninstall.sh can find it
  287. OLD_ZSHRC="$zdot/.zshrc.pre-oh-my-zsh"
  288. if [ -f "$zdot/.zshrc" ] || [ -h "$zdot/.zshrc" ]; then
  289. # Skip this if the user doesn't want to replace an existing .zshrc
  290. if [ "$KEEP_ZSHRC" = yes ]; then
  291. echo "${FMT_YELLOW}Found ${zdot}/.zshrc.${FMT_RESET} ${FMT_GREEN}Keeping...${FMT_RESET}"
  292. return
  293. fi
  294. if [ -e "$OLD_ZSHRC" ]; then
  295. OLD_OLD_ZSHRC="${OLD_ZSHRC}-$(date +%Y-%m-%d_%H-%M-%S)"
  296. if [ -e "$OLD_OLD_ZSHRC" ]; then
  297. fmt_error "$OLD_OLD_ZSHRC exists. Can't back up ${OLD_ZSHRC}"
  298. fmt_error "re-run the installer again in a couple of seconds"
  299. exit 1
  300. fi
  301. mv "$OLD_ZSHRC" "${OLD_OLD_ZSHRC}"
  302. echo "${FMT_YELLOW}Found old .zshrc.pre-oh-my-zsh." \
  303. "${FMT_GREEN}Backing up to ${OLD_OLD_ZSHRC}${FMT_RESET}"
  304. fi
  305. echo "${FMT_YELLOW}Found ${zdot}/.zshrc.${FMT_RESET} ${FMT_GREEN}Backing up to ${OLD_ZSHRC}${FMT_RESET}"
  306. mv "$zdot/.zshrc" "$OLD_ZSHRC"
  307. fi
  308. echo "${FMT_GREEN}Using the Oh My Zsh template file and adding it to $zdot/.zshrc.${FMT_RESET}"
  309. # Modify $ZSH variable in .zshrc directory to use the literal $ZDOTDIR or $HOME
  310. omz="$ZSH"
  311. [ -z "$ZDOTDIR" ] || omz=$(echo "$omz" | sed "s|^$ZDOTDIR/|\$ZDOTDIR/|")
  312. omz=$(echo "$omz" | sed "s|^$HOME/|\$HOME/|")
  313. sed "s|^export ZSH=.*$|export ZSH=\"${omz}\"|" "$ZSH/templates/zshrc.zsh-template" > "$zdot/.zshrc-omztemp"
  314. mv -f "$zdot/.zshrc-omztemp" "$zdot/.zshrc"
  315. echo
  316. }
  317. setup_shell() {
  318. # Skip setup if the user wants or stdin is closed (not running interactively).
  319. if [ "$CHSH" = no ]; then
  320. return
  321. fi
  322. # If this user's login shell is already "zsh", do not attempt to switch.
  323. if [ "$(basename -- "$SHELL")" = "zsh" ]; then
  324. return
  325. fi
  326. # If this platform doesn't provide a "chsh" command, bail out.
  327. if ! command_exists chsh; then
  328. cat <<EOF
  329. I can't change your shell automatically because this system does not have chsh.
  330. ${FMT_BLUE}Please manually change your default shell to zsh${FMT_RESET}
  331. EOF
  332. return
  333. fi
  334. echo "${FMT_BLUE}Time to change your default shell to zsh:${FMT_RESET}"
  335. # Prompt for user choice on changing the default login shell
  336. printf '%sDo you want to change your default shell to zsh? [Y/n]%s ' \
  337. "$FMT_YELLOW" "$FMT_RESET"
  338. read -r opt
  339. case $opt in
  340. y*|Y*|"") ;;
  341. n*|N*) echo "Shell change skipped."; return ;;
  342. *) echo "Invalid choice. Shell change skipped."; return ;;
  343. esac
  344. # Check if we're running on Termux
  345. case "$PREFIX" in
  346. *com.termux*) termux=true; zsh=zsh ;;
  347. *) termux=false ;;
  348. esac
  349. if [ "$termux" != true ]; then
  350. # Test for the right location of the "shells" file
  351. if [ -f /etc/shells ]; then
  352. shells_file=/etc/shells
  353. elif [ -f /usr/share/defaults/etc/shells ]; then # Solus OS
  354. shells_file=/usr/share/defaults/etc/shells
  355. else
  356. fmt_error "could not find /etc/shells file. Change your default shell manually."
  357. return
  358. fi
  359. # Get the path to the right zsh binary
  360. # 1. Use the most preceding one based on $PATH, then check that it's in the shells file
  361. # 2. If that fails, get a zsh path from the shells file, then check it actually exists
  362. if ! zsh=$(command -v zsh) || ! grep -qx "$zsh" "$shells_file"; then
  363. if ! zsh=$(grep '^/.*/zsh$' "$shells_file" | tail -n 1) || [ ! -f "$zsh" ]; then
  364. fmt_error "no zsh binary found or not present in '$shells_file'"
  365. fmt_error "change your default shell manually."
  366. return
  367. fi
  368. fi
  369. fi
  370. # We're going to change the default shell, so back up the current one
  371. if [ -n "$SHELL" ]; then
  372. echo "$SHELL" > "$zdot/.shell.pre-oh-my-zsh"
  373. else
  374. grep "^$USER:" /etc/passwd | awk -F: '{print $7}' > "$zdot/.shell.pre-oh-my-zsh"
  375. fi
  376. echo "Changing your shell to $zsh..."
  377. # Check if user has sudo privileges to run `chsh` with or without `sudo`
  378. #
  379. # This allows the call to succeed without password on systems where the
  380. # user does not have a password but does have sudo privileges, like in
  381. # Google Cloud Shell.
  382. #
  383. # On systems that don't have a user with passwordless sudo, the user will
  384. # be prompted for the password either way, so this shouldn't cause any issues.
  385. #
  386. if user_can_sudo; then
  387. sudo -k chsh -s "$zsh" "$USER" # -k forces the password prompt
  388. else
  389. chsh -s "$zsh" "$USER" # run chsh normally
  390. fi
  391. # Check if the shell change was successful
  392. if [ $? -ne 0 ]; then
  393. fmt_error "chsh command unsuccessful. Change your default shell manually."
  394. else
  395. export SHELL="$zsh"
  396. echo "${FMT_GREEN}Shell successfully changed to '$zsh'.${FMT_RESET}"
  397. fi
  398. echo
  399. }
  400. # shellcheck disable=SC2183 # printf string has more %s than arguments ($FMT_RAINBOW expands to multiple arguments)
  401. print_success() {
  402. printf '%s %s__ %s %s %s %s %s__ %s\n' $FMT_RAINBOW $FMT_RESET
  403. printf '%s ____ %s/ /_ %s ____ ___ %s__ __ %s ____ %s_____%s/ /_ %s\n' $FMT_RAINBOW $FMT_RESET
  404. printf '%s / __ \\%s/ __ \\ %s / __ `__ \\%s/ / / / %s /_ / %s/ ___/%s __ \\ %s\n' $FMT_RAINBOW $FMT_RESET
  405. printf '%s/ /_/ /%s / / / %s / / / / / /%s /_/ / %s / /_%s(__ )%s / / / %s\n' $FMT_RAINBOW $FMT_RESET
  406. printf '%s\\____/%s_/ /_/ %s /_/ /_/ /_/%s\\__, / %s /___/%s____/%s_/ /_/ %s\n' $FMT_RAINBOW $FMT_RESET
  407. printf '%s %s %s %s /____/ %s %s %s %s....is now installed!%s\n' $FMT_RAINBOW $FMT_GREEN $FMT_RESET
  408. printf '\n'
  409. printf '\n'
  410. printf "%s %s %s\n" "Before you scream ${FMT_BOLD}${FMT_YELLOW}Oh My Zsh!${FMT_RESET} look over the" \
  411. "$(fmt_code "$(fmt_link ".zshrc" "file://$zdot/.zshrc" --text)")" \
  412. "file to select plugins, themes, and options."
  413. printf '\n'
  414. printf '%s\n' "• Follow us on Twitter: $(fmt_link @ohmyzsh https://twitter.com/ohmyzsh)"
  415. printf '%s\n' "• Join our Discord community: $(fmt_link "Discord server" https://discord.gg/ohmyzsh)"
  416. printf '%s\n' "• Get stickers, t-shirts, coffee mugs and more: $(fmt_link "Planet Argon Shop" https://shop.planetargon.com/collections/oh-my-zsh)"
  417. printf '%s\n' $FMT_RESET
  418. }
  419. main() {
  420. # Run as unattended if stdin is not a tty
  421. if [ ! -t 0 ]; then
  422. RUNZSH=no
  423. CHSH=no
  424. fi
  425. # Parse arguments
  426. while [ $# -gt 0 ]; do
  427. case $1 in
  428. --unattended) RUNZSH=no; CHSH=no ;;
  429. --skip-chsh) CHSH=no ;;
  430. --keep-zshrc) KEEP_ZSHRC=yes ;;
  431. esac
  432. shift
  433. done
  434. setup_color
  435. if ! command_exists zsh; then
  436. echo "${FMT_YELLOW}Zsh is not installed.${FMT_RESET} Please install zsh first."
  437. exit 1
  438. fi
  439. if [ -d "$ZSH" ]; then
  440. echo "${FMT_YELLOW}The \$ZSH folder already exists ($ZSH).${FMT_RESET}"
  441. if [ "$custom_zsh" = yes ]; then
  442. cat <<EOF
  443. You ran the installer with the \$ZSH setting or the \$ZSH variable is
  444. exported. You have 3 options:
  445. 1. Unset the ZSH variable when calling the installer:
  446. $(fmt_code "ZSH= sh install.sh")
  447. 2. Install Oh My Zsh to a directory that doesn't exist yet:
  448. $(fmt_code "ZSH=path/to/new/ohmyzsh/folder sh install.sh")
  449. 3. (Caution) If the folder doesn't contain important information,
  450. you can just remove it with $(fmt_code "rm -r $ZSH")
  451. EOF
  452. else
  453. echo "You'll need to remove it if you want to reinstall."
  454. fi
  455. exit 1
  456. fi
  457. setup_ohmyzsh
  458. setup_zshrc
  459. setup_shell
  460. print_success
  461. if [ $RUNZSH = no ]; then
  462. echo "${FMT_YELLOW}Run zsh to try it out.${FMT_RESET}"
  463. exit
  464. fi
  465. exec zsh -l
  466. }
  467. main "$@"